<?php

class GoogleAuthenticator {
	
	// first we init google authenticator by passing it a filename
	// for its sqlite database.
	function __construct($file) {
		if(file_exists($file)) {
			try {
				$this->dbConnector = new PDO("sqlite:$file");
			} catch(PDOException $exep) {
				$this->errorText = $exep->getMessage();
				$this->dbConnector = false;
			}			
		} else {
			setupDB();
		}
		
		$this->dbFile = $file;
	}
	
	// creates the database (tables);
	function setupDB() {
		try {
			$this->$dbConnector = new PDO("sqlite:$file");
		} catch(PDOException $exep) {
			$this->errorText = $exep->getMessage();
			$this->dbConnector = false;
		}			
	
		// here we create some tables and stuff
	}
	
	// creates "user" in the database and returns a url for
	// the phone. If user already exists, this returns false
	// if any error occurs, this returns false
	function setupUser($username) {
		$key = _createBase32Key();
	}
	
	// Replcate "user" in the database... All this really
	// does is to replace the key for the user. Returns false
	// if the user doesnt exist of the key is poop
	function replaceUser($username) {
		
	}
	
	// sets the key for a user - this is assuming you dont want
	// to use one created by the application. returns false
	// if the key is invalid or the user doesn't exist.
	function setUserKey($username, $key) {
		
	}
	
	// self explanitory?
	function deleteUser($username) {
		
	}
	
	// user has input their user name and some code, authenticate
	// it
	function authenticateUser($username, $code) {
		
	}
	
	// this function allows a user to resync their key. If too
	// many codes are called, we only check up to 20 codes in the future
	// so if the user is at 21, they'll always fail. 
	function resyncCode($username, $code1, $code2) {
			
	}
	
	// gets the error text associated with the last error
	function getErrorText() {
		return $this->errorText;
	}
	
	// create a url compatibile with google authenticator.
	function createURL($user, $key) {
		$url = "otpauth://hotp/$user?secret=$key";
		return $url;
	}
	
	// creeates a base 32 key (random)
	function createBase32Key() {
		$alphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZ234567";
		$key = "";
		for($i=0; $i<16; $i++) {
			$offset = rand(0,strlen($alphabet)-1);
			//echo "$i off is $offset\n";
			$key .= $alphabet[$offset];
		}
		
		return $key;
	}
		
	
	function helperb322hex($b32) {
        $alphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZ234567";

        $out = "";
        $dous = "";

        for($i = 0; $i < strlen($b32); $i++) {
                $in = strrpos($alphabet, $b32[$i]);
                $b = str_pad(base_convert($in, 10, 2), 5, "0", STR_PAD_LEFT);
                $out .= $b;
                $dous .= $b.".";
        }

        $ar = str_split($out,20);

        //echo "$dous, $b\n";

        //print_r($ar);
        $out2 = "";
        foreach($ar as $val) {
                $rv = str_pad(base_convert($val, 2, 16), 5, "0", STR_PAD_LEFT);
                //echo "rv: $rv from $val\n";
                $out2 .= $rv;

        }
        //echo "$out2\n";

        return $out2;
	}
	
	function helperhex2b32($hex) {
        $alphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZ234567";

        $ar = str_split($hex, 5);

        $out = "";
        foreach($ar as $var) {
                $bc = base_convert($var, 16, 2);
                $bin = str_pad($bc, 20, "0", STR_PAD_LEFT);
                $out .= $bin;
                //echo "$bc was, $var is, $bin are\n";
        }

        $out2 = "";
        $ar2 = str_split($out, 5);
        foreach($ar2 as $var2) {
                $bc = base_convert($var2, 2, 10);
                $out2 .= $alphabet[$bc];
        }

        return $out2;
	}
	
	
	// some private data bits.
	private $errorText;
	private $dbFile;
	private $dbConnector;
}
?>